diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/hextile.c vnc_unixsrc/vncviewer/hextile.c
--- vnc_unixsrc.orig/vncviewer/hextile.c	2007-02-17 22:33:46.000000000 -0500
+++ vnc_unixsrc/vncviewer/hextile.c	2009-10-16 22:54:40.000000000 -0400
@@ -30,6 +30,21 @@
 #define CARDBPP CONCAT2E(CARD,BPP)
 #define GET_PIXEL CONCAT2E(GET_PIXEL,BPP)
 
+#define FillRectangle(x, y, w, h, color)  \
+	{ \
+		XGCValues _gcv; \
+		_gcv.foreground = color; \
+		if (!appData.useXserverBackingStore) { \
+			FillScreen(x, y, w, h, _gcv.foreground); \
+		} else { \
+			XChangeGC(dpy, gc, GCForeground, &_gcv); \
+			XFillRectangle(dpy, desktopWin, gc, x, y, w, h); \
+		} \
+	}
+
+extern int skip_maybe_sync;
+extern void maybe_sync(int w, int h);
+
 static Bool
 HandleHextileBPP (int rx, int ry, int rw, int rh)
 {
@@ -41,21 +56,43 @@
   int sx, sy, sw, sh;
   CARD8 subencoding;
   CARD8 nSubrects;
+  int irect = 0, nrects = (rw * rh) / (16 * 16);
+  static int nosync_ycrop = -1;
+
+	if (nosync_ycrop < 0) {
+		nosync_ycrop = 0;
+		if (getenv("HEXTILE_YCROP_TOO")) {
+			nosync_ycrop = 1;
+		}
+	}
 
   for (y = ry; y < ry+rh; y += 16) {
     for (x = rx; x < rx+rw; x += 16) {
       w = h = 16;
-      if (rx+rw - x < 16)
+      if (rx+rw - x < 16) {
 	w = rx+rw - x;
-      if (ry+rh - y < 16)
+      }
+      if (ry+rh - y < 16) {
 	h = ry+rh - y;
+      }
+
+	if (nrects > 400 && (appData.yCrop == 0 || nosync_ycrop)) {
+		skip_maybe_sync = 0;	
+		if (irect++ % 2000 != 0) {
+			if (x < rx+rw-16 || y < ry+rh-16) {
+				skip_maybe_sync	= 1;
+			}
+		}
+	}
 
-      if (!ReadFromRFBServer((char *)&subencoding, 1))
+      if (!ReadFromRFBServer((char *)&subencoding, 1)) {
 	return False;
+      }
 
       if (subencoding & rfbHextileRaw) {
-	if (!ReadFromRFBServer(buffer, w * h * (BPP / 8)))
+	if (!ReadFromRFBServer(buffer, w * h * (BPP / 8))) {
 	  return False;
+        }
 
 	CopyDataToScreen(buffer, x, y, w, h);
 	continue;
@@ -66,14 +103,25 @@
 	  return False;
 
 #if (BPP == 8)
-      if (appData.useBGR233)
+      if (appData.useBGR233) {
 	gcv.foreground = BGR233ToPixel[bg];
-      else
+      } else
+#endif
+#if (BPP == 16)
+      if (appData.useBGR565) {
+	gcv.foreground = BGR565ToPixel[bg];
+      } else
 #endif
+      {
 	gcv.foreground = bg;
+      }
 
-      XChangeGC(dpy, gc, GCForeground, &gcv);
-      XFillRectangle(dpy, desktopWin, gc, x, y, w, h);
+#if 0
+	XChangeGC(dpy, gc, GCForeground, &gcv);
+	XFillRectangle(dpy, desktopWin, gc, x, y, w, h);
+#else
+	FillRectangle(x, y, w, h, gcv.foreground);
+#endif
 
       if (subencoding & rfbHextileForegroundSpecified)
 	if (!ReadFromRFBServer((char *)&fg, sizeof(fg)))
@@ -101,14 +149,25 @@
 	  sh = rfbHextileExtractH(*ptr);
 	  ptr++;
 #if (BPP == 8)
-	  if (appData.useBGR233)
+	  if (appData.useBGR233) {
 	    gcv.foreground = BGR233ToPixel[fg];
-	  else
+	  } else
 #endif
+#if (BPP == 16)
+	  if (appData.useBGR565) {
+	    gcv.foreground = BGR565ToPixel[fg];
+	  } else
+#endif
+	  {
 	    gcv.foreground = fg;
+	  }
 
-	  XChangeGC(dpy, gc, GCForeground, &gcv);
-	  XFillRectangle(dpy, desktopWin, gc, x+sx, y+sy, sw, sh);
+#if 0
+          XChangeGC(dpy, gc, GCForeground, &gcv);
+          XFillRectangle(dpy, desktopWin, gc, x+sx, y+sy, sw, sh);
+#else
+	  FillRectangle(x+sx, y+sy, sw, sh, gcv.foreground);
+#endif
 	}
 
       } else {
@@ -116,13 +175,22 @@
 	  return False;
 
 #if (BPP == 8)
-	if (appData.useBGR233)
+	if (appData.useBGR233) {
 	  gcv.foreground = BGR233ToPixel[fg];
-	else
+	} else
 #endif
+#if (BPP == 16)
+        if (appData.useBGR565) {
+          gcv.foreground = BGR565ToPixel[fg];
+	} else
+#endif
+	{
 	  gcv.foreground = fg;
+	}
 
+#if 0
 	XChangeGC(dpy, gc, GCForeground, &gcv);
+#endif
 
 	for (i = 0; i < nSubrects; i++) {
 	  sx = rfbHextileExtractX(*ptr);
@@ -131,7 +199,11 @@
 	  sw = rfbHextileExtractW(*ptr);
 	  sh = rfbHextileExtractH(*ptr);
 	  ptr++;
+#if 0
 	  XFillRectangle(dpy, desktopWin, gc, x+sx, y+sy, sw, sh);
+#else
+	  FillRectangle(x+sx, y+sy, sw, sh, gcv.foreground);
+#endif
 	}
       }
     }
@@ -139,3 +211,5 @@
 
   return True;
 }
+
+#undef FillRectangle
diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/listen.c vnc_unixsrc/vncviewer/listen.c
--- vnc_unixsrc.orig/vncviewer/listen.c	2001-01-16 03:07:57.000000000 -0500
+++ vnc_unixsrc/vncviewer/listen.c	2010-04-11 23:14:21.000000000 -0400
@@ -32,14 +32,88 @@
 #define FLASHDELAY 1	/* seconds */
 
 Bool listenSpecified = False;
+pid_t listenParent = 0;
 int listenPort = 0, flashPort = 0;
 
+#if 0
 static Font flashFont;
-
 static void getFlashFont(Display *d);
 static void flashDisplay(Display *d, char *user);
+#endif
+
 static Bool AllXEventsPredicate(Display *d, XEvent *ev, char *arg);
 
+void raiseme(int force);
+
+static int accept_popup_check(int *argc, char **argv, char *sip, char *sih) {
+	char line[16];
+	char msg[1000];
+	int dopopup = 1;
+
+	if (!getenv("SSVNC_ACCEPT_POPUP")) {
+		return 1;
+	}
+	
+	if (!dopopup && use_tty()) {
+		raiseme(1);
+		fprintf(stderr, "Accept VNC connection? y/[n] ");
+		fgets(line, sizeof(line), stdin);
+		if (!strchr(line, 'y') && !strchr(line, 'Y')) {
+			fprintf(stderr, "Refusing connection.\n");
+			return 0;
+		} else {
+			fprintf(stderr, "Accepting connection.\n");
+			return 1;
+		}
+	} else {
+		int pid, pid2, accept_it = 0;
+
+		pid = fork();
+		if (pid == -1) {
+			perror("fork"); 
+			exit(1);
+		}
+		if (pid == 0) {
+			char *geometry = "2x2+0+0";
+			String fb[] = { "*message.Scroll: whenNeeded", NULL};
+			close(rfbsock);
+
+			toplevel = XtAppInitialize(&appContext, "Ssvnc", cmdLineOptions, numCmdLineOptions,
+			    argc, argv, fb, NULL, 0);
+			XtVaSetValues(toplevel, XtNmaxWidth, 2, XtNmaxHeight, 2, NULL);
+			XtVaSetValues(toplevel, XtNgeometry, geometry, NULL);
+			XtRealizeWidget(toplevel);
+			dpy = XtDisplay(toplevel);
+			sprintf(msg, "\n(LISTEN) Reverse VNC connection from IP: %s\n                               Hostname: %s\n\n", sip, sih);
+			strcat(msg, "Accept or Reject VNC connection?");
+			if (CreateMsg(msg, 2)) {
+				XCloseDisplay(dpy);
+				exit(0);
+			} else {
+				XCloseDisplay(dpy);
+				exit(1);
+			}
+		} else {
+			int status;
+			pid2 = waitpid(pid, &status, 0);
+			fprintf(stderr, "waitpid: %d/%d status: %d\n", pid, pid2, status);
+			if (pid2 == pid) {
+				if (WIFEXITED(status) && WEXITSTATUS(status) == 0) {
+					accept_it = 1;
+				}
+			}
+		}
+		if (accept_it) {
+			fprintf(stderr, "Accepting connection.\n");
+			return 1;
+		} else {
+			fprintf(stderr, "Refusing connection.\n");
+			return 0;
+		}
+	}
+	return 0;
+}
+
 /*
  * listenForIncomingConnections() - listen for incoming connections from
  * servers, and fork a new process to deal with each connection.  We must do
@@ -47,145 +121,291 @@
  * cope with forking very well.
  */
 
+extern char *accept6_hostname;
+extern char *accept6_ipaddr;
+
 void
 listenForIncomingConnections(int *argc, char **argv, int listenArgIndex)
 {
-  Display *d;
-  XEvent ev;
-  int listenSocket, flashSocket, sock;
-  fd_set fds;
-  char flashUser[256];
-  int n;
-  int i;
-  char *displayname = NULL;
-
-  listenSpecified = True;
-
-  for (i = 1; i < *argc; i++) {
-    if (strcmp(argv[i], "-display") == 0 && i+1 < *argc) {
-      displayname = argv[i+1];
-    }
-  }
+	Display *d;
+	XEvent ev;
+	int listenSocket, listenSocket6, flashSocket, sock;
+	fd_set fds;
+	char flashUser[256];
+	int n;
+	int i;
+	char *displayname = NULL;
+	int children = 0;
+	int totalconn = 0, maxconn = 0;
+
+	listenSpecified = True;
+	listenParent = getpid();
+
+	for (i = 1; i < *argc; i++) {
+		if (strcmp(argv[i], "-display") == 0 && i+1 < *argc) {
+			displayname = argv[i+1];
+		}
+	}
+	if (sock || flashUser || n) {}
 
-  if (listenArgIndex+1 < *argc && argv[listenArgIndex+1][0] >= '0' &&
+	if (listenArgIndex+1 < *argc && argv[listenArgIndex+1][0] >= '0' &&
 					    argv[listenArgIndex+1][0] <= '9') {
 
-    listenPort = LISTEN_PORT_OFFSET + atoi(argv[listenArgIndex+1]);
-    flashPort = FLASH_PORT_OFFSET + atoi(argv[listenArgIndex+1]);
-    removeArgs(argc, argv, listenArgIndex, 2);
+		listenPort = LISTEN_PORT_OFFSET + atoi(argv[listenArgIndex+1]);
+		flashPort = FLASH_PORT_OFFSET + atoi(argv[listenArgIndex+1]);
+		removeArgs(argc, argv, listenArgIndex, 2);
 
-  } else {
+	} else {
 
-    char *display;
-    char *colonPos;
-    struct utsname hostinfo;
+		char *display;
+		char *colonPos;
+		struct utsname hostinfo;
 
-    removeArgs(argc, argv, listenArgIndex, 1);
+		removeArgs(argc, argv, listenArgIndex, 1);
 
-    display = XDisplayName(displayname);
-    colonPos = strchr(display, ':');
+		display = XDisplayName(displayname);
+		colonPos = strchr(display, ':');
 
-    uname(&hostinfo);
+		uname(&hostinfo);
 
-    if (colonPos && ((colonPos == display) ||
-		     (strncmp(hostinfo.nodename, display,
-			      strlen(hostinfo.nodename)) == 0))) {
+		if (colonPos && ((colonPos == display) ||
+			     (strncmp(hostinfo.nodename, display,
+				      strlen(hostinfo.nodename)) == 0))) {
 
-      listenPort = LISTEN_PORT_OFFSET + atoi(colonPos+1);
-      flashPort = FLASH_PORT_OFFSET + atoi(colonPos+1);
+			listenPort = LISTEN_PORT_OFFSET + atoi(colonPos+1);
+			flashPort = FLASH_PORT_OFFSET + atoi(colonPos+1);
 
-    } else {
-      fprintf(stderr,"%s: cannot work out which display number to "
-	      "listen on.\n", programName);
-      fprintf(stderr,"Please specify explicitly with -listen <num>\n");
-      exit(1);
-    }
-  }
+		} else {
+			fprintf(stderr,"%s: cannot work out which display number to "
+			      "listen on.\n", programName);
+			fprintf(stderr,"Please specify explicitly with -listen <num>\n");
+			exit(1);
+		}
 
-  if (!(d = XOpenDisplay(displayname))) {
-    fprintf(stderr,"%s: unable to open display %s\n",
-	    programName, XDisplayName(displayname));
-    exit(1);
-  }
+	}
 
-  getFlashFont(d);
+	if (!(d = XOpenDisplay(displayname))) {
+		fprintf(stderr,"%s: unable to open display %s\n",
+		    programName, XDisplayName(displayname));
+		exit(1);
+	}
 
-  listenSocket = ListenAtTcpPort(listenPort);
-  flashSocket = ListenAtTcpPort(flashPort);
+#if 0
+	getFlashFont(d);
+#endif
 
-  if ((listenSocket < 0) || (flashSocket < 0)) exit(1);
+	listenSocket  = ListenAtTcpPort(listenPort);
+	listenSocket6 = ListenAtTcpPort6(listenPort);
+
+#if 0
+	flashSocket = ListenAtTcpPort(flashPort);
+#endif
+	flashSocket = 1234;
+
+	if (listenSocket < 0 && listenSocket6 < 0) {
+		fprintf(stderr,"%s -listen: could not obtain a listening socket on port %d\n",
+		    programName, listenPort);
+		exit(1);
+	}
 
-  fprintf(stderr,"%s -listen: Listening on port %d (flash port %d)\n",
-	  programName,listenPort,flashPort);
-  fprintf(stderr,"%s -listen: Command line errors are not reported until "
+	fprintf(stderr,"%s -listen: Listening on port %d  ipv4_fd: %d ipv6_fd: %d\n",
+	  programName, listenPort, listenSocket, listenSocket6);
+	fprintf(stderr,"%s -listen: Cmdline errors are not reported until "
 	  "a connection comes in.\n", programName);
 
-  while (True) {
+	/* this will only work if X events drives this loop -- they don't */
+	if (getenv("SSVNC_MAX_LISTEN")) {
+		maxconn = atoi(getenv("SSVNC_MAX_LISTEN"));
+	}
 
-    /* reap any zombies */
-    int status, pid;
-    while ((pid= wait3(&status, WNOHANG, (struct rusage *)0))>0);
-
-    /* discard any X events */
-    while (XCheckIfEvent(d, &ev, AllXEventsPredicate, NULL))
-      ;
-
-    FD_ZERO(&fds); 
-
-    FD_SET(flashSocket, &fds);
-    FD_SET(listenSocket, &fds);
-    FD_SET(ConnectionNumber(d), &fds);
-
-    select(FD_SETSIZE, &fds, NULL, NULL, NULL);
-
-    if (FD_ISSET(flashSocket, &fds)) {
-
-      sock = AcceptTcpConnection(flashSocket);
-      if (sock < 0) exit(1);
-      n = read(sock, flashUser, 255);
-      if (n > 0) {
-	flashUser[n] = 0;
-	flashDisplay(d, flashUser);
-      } else {
-	flashDisplay(d, NULL);
-      }
-      close(sock);
-    }
+    while (True) {
+	int lsock = -1;
 
-    if (FD_ISSET(listenSocket, &fds)) {
-      rfbsock = AcceptTcpConnection(listenSocket);
-      if (rfbsock < 0) exit(1);
-      if (!SetNonBlocking(rfbsock)) exit(1);
+	/* reap any zombies */
+	int status, pid;
+	while ((pid = wait3(&status, WNOHANG, (struct rusage *)0))>0) {
+		if (pid > 0 && children > 0) {
+			children--;	
+			/* this will only work if X events drives this loop -- they don't */
+			if (maxconn > 0 && totalconn >= maxconn) {
+				fprintf(stderr,"%s -listen: Finished final connection %d\n",
+				    programName, maxconn);
+				exit(0);
+			}
+		}
+	}
 
-      XCloseDisplay(d);
+	/* discard any X events */
+	while (XCheckIfEvent(d, &ev, AllXEventsPredicate, NULL)) {
+		;
+	}
 
-      /* Now fork off a new process to deal with it... */
+	FD_ZERO(&fds); 
 
-      switch (fork()) {
+#if 0
+	FD_SET(flashSocket, &fds);
+#endif
+	if (listenSocket >= 0) {
+    		FD_SET(listenSocket, &fds);
+	}
+	if (listenSocket6 >= 0) {
+    		FD_SET(listenSocket6, &fds);
+	}
+	FD_SET(ConnectionNumber(d), &fds);
 
-      case -1: 
-	perror("fork"); 
-	exit(1);
+	select(FD_SETSIZE, &fds, NULL, NULL, NULL);
 
-      case 0:
-	/* child - return to caller */
-	close(listenSocket);
-	close(flashSocket);
-	return;
+	while ((pid = wait3(&status, WNOHANG, (struct rusage *)0))>0) {
+		if (pid > 0 && children > 0) {
+			children--;	
+			if (maxconn > 0 && totalconn >= maxconn) {
+				fprintf(stderr,"%s -listen: Finished final connection %d\n",
+				programName, maxconn);
+				exit(0);
+			}
+		}
+	}
 
-      default:
-	/* parent - go round and listen again */
-	close(rfbsock); 
-	if (!(d = XOpenDisplay(displayname))) {
-	  fprintf(stderr,"%s: unable to open display %s\n",
-		  programName, XDisplayName(displayname));
-	  exit(1);
+#if 0
+	if (FD_ISSET(flashSocket, &fds)) {
+		sock = AcceptTcpConnection(flashSocket);
+		if (sock < 0) exit(1);
+		n = read(sock, flashUser, 255);
+		if (n > 0) {
+			flashUser[n] = 0;
+			flashDisplay(d, flashUser);
+		} else {
+			flashDisplay(d, NULL);
+		}
+		close(sock);
+	}
+#endif
+
+	lsock = -1;
+	if (listenSocket >= 0 && FD_ISSET(listenSocket, &fds)) {
+		lsock = listenSocket;
+	} else if (listenSocket6 >= 0 && FD_ISSET(listenSocket6, &fds)) {
+		lsock = listenSocket6;
+	}
+
+	if (lsock >= 0) {
+		int multi_ok = 0;
+		char *sml = getenv("SSVNC_MULTIPLE_LISTEN");
+		char *sip = NULL;
+		char *sih = NULL;
+
+		if (lsock == listenSocket) {
+			rfbsock = AcceptTcpConnection(lsock);
+		} else {
+			rfbsock = AcceptTcpConnection6(lsock);
+		}
+
+		if (sml != NULL) {
+			if (strstr(sml, "MAX:") == sml || strstr(sml, "max:") == sml) {
+				char *q = strchr(sml, ':');
+				int maxc = atoi(q+1);
+				if (maxc == 0 && strcmp(q+1, "0")) {
+					maxc = -99;
+				}
+				if (maxc < 0) {
+					fprintf(stderr, "invalid SSVNC_MULTIPLE_LISTEN=MAX:n, %s, must be 0 or positive, using 1\n", sml); 
+				} else if (maxc == 0) {
+					multi_ok = 1;
+				} else if (children < maxc) {
+					multi_ok = 1;
+				}
+			} else if (strcmp(sml, "") && strcmp(sml, "0")) {
+				multi_ok = 1;
+			}
+		}
+
+		if (rfbsock < 0) exit(1);
+		if (!SetNonBlocking(rfbsock)) exit(1);
+
+		if (children > 0 && !multi_ok) {
+			fprintf(stderr,"\n");
+			fprintf(stderr,"%s: denying extra incoming connection (%d already)\n",
+			    programName, children);
+			fprintf(stderr,"%s: to override: use '-multilisten' or set SSVNC_MULTIPLE_LISTEN=1\n",
+			    programName);
+			fprintf(stderr,"\n");
+			close(rfbsock);
+			rfbsock = -1;
+			continue;
+		}
+
+		if (lsock == listenSocket) {
+			sip = get_peer_ip(rfbsock);
+			if (strlen(sip) > 100) sip = "0.0.0.0";
+			sih = ip2host(sip);
+			if (strlen(sih) > 300) sih = "unknown";
+		} else {
+			if (accept6_hostname != NULL) {
+				sip = accept6_ipaddr;
+				accept6_ipaddr = NULL;
+				sih = accept6_hostname;
+				accept6_hostname = NULL;
+			} else {
+				sip = "unknown";
+				sih = "unknown";
+			}
+		}
+
+		fprintf(stderr, "\n");
+		fprintf(stderr, "(LISTEN) Reverse VNC connection from IP: %s\n", sip);
+		fprintf(stderr, "                               Hostname: %s\n\n", sih);
+
+		if (sml == NULL && !accept_popup_check(argc, argv, sip, sih)) {
+			close(rfbsock);
+			rfbsock = -1;
+			continue;
+		}
+
+		totalconn++;
+
+		XCloseDisplay(d);
+
+		/* Now fork off a new process to deal with it... */
+
+		switch (fork()) {
+
+		case -1: 
+			perror("fork"); 
+			exit(1);
+
+		case 0:
+			/* child - return to caller */
+			close(listenSocket);
+#if 0
+			close(flashSocket);
+#endif
+			if (sml != NULL && !accept_popup_check(argc, argv, sip, sih)) {
+				close(rfbsock);
+				rfbsock = -1;
+				exit(0);
+			}
+			return;
+
+		default:
+			/* parent - go round and listen again */
+			children++;
+			close(rfbsock);
+			if (!(d = XOpenDisplay(displayname))) {
+				fprintf(stderr,"%s: unable to open display %s\n",
+				    programName, XDisplayName(displayname));
+				exit(1);
+			}
+#if 0
+			getFlashFont(d);
+#endif
+			fprintf(stderr,"\n\n%s -listen: Listening on port %d\n",
+			    programName,listenPort);
+			fprintf(stderr,"%s -listen: Cmdline errors are not reported until "
+			    "a connection comes in.\n\n", programName);
+			break;
+		}
 	}
-	getFlashFont(d);
-	break;
-      }
     }
-  }
 }
 
 
@@ -193,9 +413,16 @@
  * getFlashFont
  */
 
+#if 0
 static void
 getFlashFont(Display *d)
 {
+
+#if 1
+	/* no longer used */
+	if (d) {}
+	return;
+#else
   char fontName[256];
   char **fontNames;
   int nFontNames;
@@ -209,6 +436,9 @@
     sprintf(fontName,"fixed");
   }
   flashFont = XLoadFont(d, fontName);
+
+#endif
+
 }
 
 
@@ -219,6 +449,11 @@
 static void
 flashDisplay(Display *d, char *user)
 {
+#if 1
+	/* no longer used */
+	if (d || user) {}
+	return;
+#else
   Window w1, w2, w3, w4;
   XSetWindowAttributes attr;
 
@@ -284,7 +519,11 @@
   XDestroyWindow(d, w3);
   XDestroyWindow(d, w4);
   XFlush(d);
+
+#endif
+
 }
+#endif
 
 /*
  * AllXEventsPredicate is needed to make XCheckIfEvent return all events.
@@ -293,5 +532,6 @@
 static Bool
 AllXEventsPredicate(Display *d, XEvent *ev, char *arg)
 {
-  return True;
+	if (d || ev || arg) {}
+	return True;
 }
diff -Naur -X ./exclude vnc_unixsrc.orig/vncviewer/misc.c vnc_unixsrc/vncviewer/misc.c
--- vnc_unixsrc.orig/vncviewer/misc.c	2003-01-15 02:58:32.000000000 -0500
+++ vnc_unixsrc/vncviewer/misc.c	2010-02-25 22:44:09.000000000 -0500
@@ -23,6 +23,7 @@
 
 #include <vncviewer.h>
 #include <signal.h>
+#include <sys/wait.h>
 #include <fcntl.h>
 
 static void CleanupSignalHandler(int sig);
@@ -33,12 +34,20 @@
 
 Dimension dpyWidth, dpyHeight;
 Atom wmDeleteWindow, wmState;
+int fullscreen_startup = 0;
 
 static Bool xloginIconified = False;
 static XErrorHandler defaultXErrorHandler;
 static XIOErrorHandler defaultXIOErrorHandler;
 static XtErrorHandler defaultXtErrorHandler;
 
+int XError_ign = 0;
+
+void check_tall(void);
+int guessCrop(void);
+void get_scale_values(double *fx, double *fy);
+int scale_round(int n, double factor);
+Bool SendTextChatFinished(void);
 
 /*
  * ToplevelInitBeforeRealization sets the title, geometry and other resources
@@ -48,87 +57,122 @@
 void
 ToplevelInitBeforeRealization()
 {
-  char *titleFormat;
-  char *title;
-  char *geometry;
-
-  XtVaGetValues(toplevel, XtNtitle, &titleFormat, NULL);
-  title = XtMalloc(strlen(titleFormat) + strlen(desktopName) + 1);
-  sprintf(title, titleFormat, desktopName);
-  XtVaSetValues(toplevel, XtNtitle, title, XtNiconName, title, NULL);
-
-  XtVaSetValues(toplevel, XtNmaxWidth, si.framebufferWidth,
-		XtNmaxHeight, si.framebufferHeight, NULL);
-
-  dpyWidth = WidthOfScreen(DefaultScreenOfDisplay(dpy));
-  dpyHeight = HeightOfScreen(DefaultScreenOfDisplay(dpy));
-
-  if (appData.fullScreen) {
-
-    /* full screen - set position to 0,0, but defer size calculation until
-       widgets are realized */
-
-    XtVaSetValues(toplevel, XtNoverrideRedirect, True,
-		  XtNgeometry, "+0+0", NULL);
-
-  } else {
-
-    /* not full screen - work out geometry for middle of screen unless
-       specified by user */
-
-    XtVaGetValues(toplevel, XtNgeometry, &geometry, NULL);
-
-    if (geometry == NULL) {
-      Dimension toplevelX, toplevelY;
-      Dimension toplevelWidth = si.framebufferWidth;
-      Dimension toplevelHeight = si.framebufferHeight;
-
-      if ((toplevelWidth + appData.wmDecorationWidth) >= dpyWidth)
-	toplevelWidth = dpyWidth - appData.wmDecorationWidth;
-
-      if ((toplevelHeight + appData.wmDecorationHeight) >= dpyHeight)
-	toplevelHeight = dpyHeight - appData.wmDecorationHeight;
-
-      toplevelX = (dpyWidth - toplevelWidth - appData.wmDecorationWidth) / 2;
-
-      toplevelY = (dpyHeight - toplevelHeight - appData.wmDecorationHeight) /2;
-
-      /* set position via "geometry" so that window manager thinks it's a
-	 user-specified position and therefore honours it */
-
-      geometry = XtMalloc(256);
-
-      sprintf(geometry, "%dx%d+%d+%d",
-	      toplevelWidth, toplevelHeight, toplevelX, toplevelY);
-      XtVaSetValues(toplevel, XtNgeometry, geometry, NULL);
-    }
-  }
+	char *titleFormat;
+	char *title;
+	char *geometry;
+	int h = si.framebufferHeight;
+	int w = si.framebufferWidth;
+
+	check_tall();
+	if (appData.yCrop < 0) {
+		appData.yCrop = guessCrop();
+		fprintf(stderr, "Set -ycrop to: %d\n", appData.yCrop);
+		if (appData.yCrop > 0) {
+			h = appData.yCrop;
+		}
+	}
+	
+	XtVaGetValues(toplevel, XtNtitle, &titleFormat, NULL);
+	title = XtMalloc(strlen(titleFormat) + strlen(desktopName) + 1);
+	sprintf(title, titleFormat, desktopName);
+	XtVaSetValues(toplevel, XtNtitle, title, XtNiconName, title, NULL);
+
+	if (appData.scale != NULL) {
+		/* switched to not scaled */
+		double frac_x, frac_y;
+		get_scale_values(&frac_x, &frac_y);
+		if (frac_x > 0.0 && frac_y > 0.0) {
+			w = scale_round(w, frac_x);
+			h = scale_round(h, frac_y);
+		}
+	}
+	XtVaSetValues(toplevel, XtNmaxWidth, w, XtNmaxHeight, h, NULL);
+
+	dpyWidth  = WidthOfScreen(DefaultScreenOfDisplay(dpy));
+	dpyHeight = HeightOfScreen(DefaultScreenOfDisplay(dpy));
+
+	if (appData.fullScreen) {
+		/* full screen - set position to 0,0, but defer size calculation until widgets are realized */
+
+		if (!net_wm_supported()) {
+			XtVaSetValues(toplevel, XtNoverrideRedirect, True, XtNgeometry, "+0+0", NULL);
+		} else {
+			fullscreen_startup = 1;
+		}
+
+	} else {
+
+		/* not full screen - work out geometry for middle of screen unless specified by user */
+
+		XtVaGetValues(toplevel, XtNgeometry, &geometry, NULL);
+
+		if (geometry == NULL) {
+			Dimension toplevelX, toplevelY;
+			Dimension toplevelWidth  = w;
+			Dimension toplevelHeight = h;
+
+			if ((toplevelWidth + appData.wmDecorationWidth) >= dpyWidth) {
+				toplevelWidth = dpyWidth - appData.wmDecorationWidth;
+			}
+
+			if ((toplevelHeight + appData.wmDecorationHeight) >= dpyHeight) {
+				toplevelHeight = dpyHeight - appData.wmDecorationHeight;
+			}
+
+			toplevelX = (dpyWidth  - toplevelWidth  - appData.wmDecorationWidth) / 2;
+			toplevelY = (dpyHeight - toplevelHeight - appData.wmDecorationHeight) /2;
+
+			if (appData.appShare) {
+				int X = appshare_x_hint;
+				int Y = appshare_y_hint;
+				if (appData.scale) {
+					double fx = 1.0, fy = 1.0;
+					get_scale_values(&fx, &fy);
+					if (fx > 0.0 && fy > 0.0) {
+						X *= fx;
+						Y *= fy;
+					}
+				}
+				if (appshare_x_hint != appshare_0_hint) {
+					toplevelX = X;
+				}
+				if (appshare_y_hint != appshare_0_hint) {
+					toplevelY = Y;
+				}
+			}
+
+			/* set position via "geometry" so that window manager thinks it's a
+			 user-specified position and therefore honours it */
+
+			geometry = XtMalloc(256);
+
+			sprintf(geometry, "%dx%d+%d+%d", toplevelWidth, toplevelHeight, toplevelX, toplevelY);
+			fprintf(stderr, "geometry: %s ycrop: %d\n", geometry, appData.yCrop);
+			XtVaSetValues(toplevel, XtNgeometry, geometry, NULL);
+		}
+	}
 
   /* Test if the keyboard is grabbed.  If so, it's probably because the
      XDM login window is up, so try iconifying it to release the grab */
 
-  if (XGrabKeyboard(dpy, DefaultRootWindow(dpy), False, GrabModeSync,
-		    GrabModeSync, CurrentTime) == GrabSuccess) {
-    XUngrabKeyboard(dpy, CurrentTime);
-  } else {
-    wmState = XInternAtom(dpy, "WM_STATE", False);
-
-    if (IconifyNamedWindow(DefaultRootWindow(dpy), "xlogin", False)) {
-      xloginIconified = True;
-      XSync(dpy, False);
-      sleep(1);
-    }
-  }
-
-  /* Set handlers for signals and X errors to perform cleanup */
-
-  signal(SIGHUP, CleanupSignalHandler);
-  signal(SIGINT, CleanupSignalHandler);
-  signal(SIGTERM, CleanupSignalHandler);
-  defaultXErrorHandler = XSetErrorHandler(CleanupXErrorHandler);
-  defaultXIOErrorHandler = XSetIOErrorHandler(CleanupXIOErrorHandler);
-  defaultXtErrorHandler = XtAppSetErrorHandler(appContext,
-					       CleanupXtErrorHandler);
+	if (XGrabKeyboard(dpy, DefaultRootWindow(dpy), False, GrabModeSync, GrabModeSync, CurrentTime) == GrabSuccess) {
+		XUngrabKeyboard(dpy, CurrentTime);
+	} else {
+		wmState = XInternAtom(dpy, "WM_STATE", False);
+		if (IconifyNamedWindow(DefaultRootWindow(dpy), "xlogin", False)) {
+			xloginIconified = True;
+			XSync(dpy, False);
+			sleep(1);
+		}
+	}
+
+	/* Set handlers for signals and X errors to perform cleanup */
+	signal(SIGHUP,  CleanupSignalHandler);
+	signal(SIGINT,  CleanupSignalHandler);
+	signal(SIGTERM, CleanupSignalHandler);
+	defaultXErrorHandler   = XSetErrorHandler(CleanupXErrorHandler);
+	defaultXIOErrorHandler = XSetIOErrorHandler(CleanupXIOErrorHandler);
+	defaultXtErrorHandler  = XtAppSetErrorHandler(appContext, CleanupXtErrorHandler);
 }
 
 
@@ -141,14 +185,22 @@
 void
 ToplevelInitAfterRealization()
 {
-  if (appData.fullScreen) {
-    FullScreenOn();
-  }
-
-  wmDeleteWindow = XInternAtom(dpy, "WM_DELETE_WINDOW", False);
-  XSetWMProtocols(dpy, XtWindow(toplevel), &wmDeleteWindow, 1);
-  XtOverrideTranslations
-      (toplevel, XtParseTranslationTable ("<Message>WM_PROTOCOLS: Quit()"));
+	if (appData.fullScreen) {
+		FullScreenOn();
+		if (net_wm_supported()) {
+			/* problem with scroll bars sticking: */
+      			XSync(dpy, False);
+  			usleep(50 * 1000);
+			FullScreenOff();
+      			XSync(dpy, False);
+  			usleep(50 * 1000);
+			FullScreenOn();
+		}
+	}
+
+	wmDeleteWindow = XInternAtom(dpy, "WM_DELETE_WINDOW", False);
+	XSetWMProtocols(dpy, XtWindow(toplevel), &wmDeleteWindow, 1);
+	XtOverrideTranslations(toplevel, XtParseTranslationTable ("<Message>WM_PROTOCOLS: Quit()"));
 }
 
 
@@ -157,9 +209,7 @@
  * CurrentTime if the event has no time field.
  */
 
-Time
-TimeFromEvent(XEvent *ev)
-{
+Time TimeFromEvent(XEvent *ev) {
   switch (ev->type) {
   case KeyPress:
   case KeyRelease:
@@ -192,18 +242,16 @@
  * generated by SendRFBEvent.
  */
 
-void
-Pause(Widget w, XEvent *event, String *params, Cardinal *num_params)
-{
-  int msec;
+void Pause(Widget w, XEvent *event, String *params, Cardinal *num_params) {
+	int msec;
 
-  if (*num_params == 0) {
-    msec = 100;
-  } else {
-    msec = atoi(params[0]);
-  }
-
-  usleep(msec * 1000);
+	if (*num_params == 0) {
+		msec = 100;
+	} else {
+		msec = atoi(params[0]);
+	}
+	usleep(msec * 1000);
+	if (w || event || params || num_params) {}
 }
 
 
@@ -256,6 +304,7 @@
   /* Wait for Child 1 to die */
   wait(&childstatus);
   
+	if (w || event || params || num_params) {}
   return;
 }
 
@@ -264,11 +313,10 @@
  * Quit action - called when we get a "delete window" message.
  */
 
-void
-Quit(Widget w, XEvent *event, String *params, Cardinal *num_params)
-{
-  Cleanup();
-  exit(0);
+void Quit(Widget w, XEvent *event, String *params, Cardinal *num_params) {
+	Cleanup();
+	if (w || event || params || num_params) {}
+	exit(0);
 }
 
 
@@ -276,49 +324,94 @@
  * Cleanup - perform any cleanup operations prior to exiting.
  */
 
-void
-Cleanup()
-{
-  if (xloginIconified) {
-    IconifyNamedWindow(DefaultRootWindow(dpy), "xlogin", True);
-    XFlush(dpy);
-  }
+void Cleanup() {
+
+	if (appData.chatActive) {
+		appData.chatActive = False;
+		fprintf(stderr,"Sending SendTextChatClose()\n");
+		SendTextChatClose();
+		SendTextChatFinished();
+	}
+
+	if (xloginIconified) {
+		IconifyNamedWindow(DefaultRootWindow(dpy), "xlogin", True);
+		XFlush(dpy);
+	}
 #ifdef MITSHM
-  if (appData.useShm)
-    ShmCleanup();
+	if (appData.useShm) {
+		if (UsingShm()) {
+			ShmDetach();
+		}
+		ShmCleanup();
+	}
 #endif
+
+	releaseAllPressedModifiers();
+
+	fprintf(stderr,"\nVNC Viewer exiting.\n\n");
+	if (listenSpecified) {
+		if (listenParent != 0 && getenv("SSVNC_LISTEN_ONCE") && listenParent != getpid()) {
+			fprintf(stderr, "SSVNC_LISTEN_ONCE: Trying to kill Listening Parent: %d\n", (int) listenParent);
+			fprintf(stderr, "SSVNC_LISTEN_ONCE: Press Ctrl-C if it continues to Listen.\n\n");
+			kill(listenParent, SIGTERM);
+		} else {
+			fprintf(stderr,"(NOTE: You may need to Press Ctrl-C to make the Viewer Stop Listening.)\n\n");
+		}
+	}
+}
+
+static void check_dbg(void) {
+	if (getenv("SSVNC_EXIT_DEBUG")) {
+		fprintf(stderr, "Press any key to continue: ");
+		getc(stdin);
+	}
 }
 
 static int
 CleanupXErrorHandler(Display *dpy, XErrorEvent *error)
 {
-  fprintf(stderr,"CleanupXErrorHandler called\n");
-  Cleanup();
-  return (*defaultXErrorHandler)(dpy, error);
+	if (XError_ign) {
+		char str[4096];
+		XError_ign++;
+		fprintf(stderr,"XError_ign called.\n");
+		str[0] = '\0';
+		if (XGetErrorText(dpy, error->error_code, str, 4096)) {
+			fprintf(stderr, "%s", str);
+		}
+		return 0;
+	}
+	fprintf(stderr,"CleanupXErrorHandler called\n");
+	check_dbg();
+	Cleanup();
+	return (*defaultXErrorHandler)(dpy, error);
 }
 
 static int
 CleanupXIOErrorHandler(Display *dpy)
 {
-  fprintf(stderr,"CleanupXIOErrorHandler called\n");
-  Cleanup();
-  return (*defaultXIOErrorHandler)(dpy);
+	fprintf(stderr,"CleanupXIOErrorHandler called\n");
+	check_dbg();
+	Cleanup();
+	return (*defaultXIOErrorHandler)(dpy);
 }
 
 static void
 CleanupXtErrorHandler(String message)
 {
-  fprintf(stderr,"CleanupXtErrorHandler called\n");
-  Cleanup();
-  (*defaultXtErrorHandler)(message);
+	fprintf(stderr,"CleanupXtErrorHandler called\n");
+	check_dbg();
+	Cleanup();
+	(*defaultXtErrorHandler)(message);
 }
 
 static void
 CleanupSignalHandler(int sig)
 {
-  fprintf(stderr,"CleanupSignalHandler called\n");
-  Cleanup();
-  exit(1);
+	fprintf(stderr,"CleanupSignalHandler called\n");
+	check_dbg();
+	Cleanup();
+	if (sig) {}
+	exit(1);
 }
 
 
@@ -362,7 +455,7 @@
   if (!XQueryTree(dpy, w, &dummy, &dummy, &children, &nchildren))
     return False;
 
-  for (i = 0; i < nchildren; i++) {
+  for (i = 0; i < (int) nchildren; i++) {
     if (IconifyNamedWindow(children[i], name, undo)) {
       XFree ((char *)children);
       return True;
